/*        CVS: $Id: UBC_ISCAS89_sim.v,v 1.1.1.1 2009/03/06 04:48:33 depaulfm Exp $ */

/*
# LICENSE AGREEMENT
#
#  FileName                   [UBC_ISCAS89_sim.v]
#
#  PackageName                [BackSpace]
#
#  Synopsis                   [Use this file for simulation only]
#
#  Author                     [FLAVIO M DE PAULA]
#
#  Copyright                  [Copyright (C) 2009 University of British Columbia]
# 
#  This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

 
 
 	date : "February 11, 2009";
	revision : 1.0;
*/




/*****
 *
 * AND 
 *
******/
module AN2isc(Z, A, B);
   output Z;
   input  A;
   input  B;

   and(Z, A, B);
   
endmodule // AN2


module AN3isc(Z, A, B, C);
   output Z;
   input  A;
   input  B;
   input  C;

   and(Z, A, B, C);
       
endmodule // AN3

module AN4isc(Z, A, B, C, D);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
    
   and(Z, A, B, C, D);
  
endmodule // AN4

module AN5isc(Z, A, B, C, D, E);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
   input  E;
    
   and(Z, A, B, C, D, E);
  
endmodule // AN5

/*****
 *
 *  NAND 
 * 
*******/
module ND2isc(Z, A, B);
   output Z;
   input  A;
   input  B;

   nand(Z, A, B);
   
endmodule // ND2

module ND3isc(Z, A, B, C);
   output Z;
   input  A;
   input  B;
   input  C;

   nand(Z, A, B, C);

endmodule // ND3

module ND4isc(Z, A, B, C, D);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;

   nand(Z, A, B, C, D);

endmodule // ND4

module ND5isc(Z, A, B, C, D, E);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
   input  E;
    
   nand(Z, A, B, C, D, E);
  
endmodule // ND5

/*****
 * 
 * OR 
 * 
*******/
module OR2isc(Z, A, B);
   output Z;
   input  A;
   input  B;

   or(Z, A, B);
     
endmodule // OR2

module OR3isc(Z, A, B, C);
   output Z;
   input  A;
   input  B;
   input  C;
   
   or(Z, A, B, C);
     
endmodule // OR3

module OR4isc(Z, A, B, C, D);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
   
   or(Z, A, B, C, D);
     
endmodule // OR4

/*****
 * 
 * NOR 
 * 
*******/
module NR2isc(Z, A, B);
   output Z;
   input  A;
   input  B;

   nor(Z, A, B);
     
endmodule // NR2

module NR3isc(Z, A, B, C);
   output Z;
   input  A;
   input  B;
   input  C;
   
   nor(Z, A, B, C);
  
endmodule // NR3

module NR4isc(Z, A, B, C, D);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
   
   nor(Z, A, B, C, D);
  
endmodule // NR4

module NR5isc(Z, A, B, C, D, E);
   output Z;
   input  A;
   input  B;
   input  C;
   input  D;
   input  E;
   
   nor(Z, A, B, C, D, E);
  
endmodule // NR5

/*****
 * 
 * NOT 
 * 
*******/
module IVisc(Z, A);
   output Z;
   input  A;

   not(Z, A);

endmodule // IV

/*****
 * 
 * DFF1 
 * 
*******/
module FD1isc(CP, Q, QN, D);
   output Q;
   output QN;
   input  CP;
   input  D;

   reg 	  flipflop; 
//synopsys translate_off
    initial flipflop = 1'b0; // ASSUMED to be cleared
//synopsys translate_on   
   always@(posedge CP)
       flipflop <= D;
   
   assign Q  = flipflop;
   assign QN = ~flipflop;
  
endmodule // DF1

/*****
 * 
 * DFF2 
 * 
*******/
module FD2isc(CP, CD, Q, QN, D);
   output Q;
   output QN;
   input  CP;
   input  CD;
   input  D;

   reg 	  flipflop; initial flipflop = 1'b0;
   
   
   always@(posedge CP)
     if(CD)
       flipflop <= 1'b0;
     else
       flipflop <= D;
   
   assign Q  = flipflop;
   assign QN = ~flipflop;
   
endmodule // DF2
/*****
 * 
 * DFF2 
 * 
*******/
module FD4isc(CP, SD, Q, QN, D);
   output Q;
   output QN;
   input  CP;
   input  SD;
   input  D;

   reg 	  flipflop; initial flipflop = 1'b1;
   
   always@(posedge CP)
     if(SD)
       flipflop <= 1'b1;
     else
       flipflop <= D;
   
   assign Q  = flipflop;
   assign QN = ~flipflop;
   
endmodule // DF4
