/*
# CVS: $Id: ext_ram_init.v,v 1.1 2009/03/30 19:42:31 depaulfm Exp $

# LICENSE AGREEMENT
#
#  FileName                   [ext_ram_init.v]
#
#  PackageName                [BackSpace]
#
#  Synopsis                   [Bus Functional Model based on OpenCore's OpenRisc]
#                             [This file is provided as is. I make no claims    ]
#                             [about its correctness. Use it at your own risk   ]
#
#  Author                     [FLAVIO M DE PAULA]
#
#  Copyright                  [Copyright (C) 2009 University of British Columbia]
# 
#  This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
//////////////////////////////////////////////////////////////////////
////                                                              ////
////  MP3 demo SRAM init                                          ////
////                                                              ////
////  This file is part of the MP3 demo application               ////
////  http://www.opencores.org/cores/or1k/mp3/                    ////
////                                                              ////
////  Description                                                 ////
////  Optional SRAM content initialization (for debugging         ////
////  purposes)                                                   ////
////                                                              ////
////  To Do:                                                      ////
////   - nothing really                                           ////
////                                                              ////
////  Author(s):                                                  ////
////      - Damjan Lampret, lampret@opencores.org                 ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2001 Authors                                   ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log: ext_ram_init.v,v $
// Revision 1.1  2009/03/30 19:42:31  depaulfm
// Bootstrapping
//
// Revision 1.1  2008/07/14 23:45:27  depaulfm
// Bootstrapping version 1/1/04
//
// Revision 1.1  2002/03/28 19:59:55  lampret
// Added bench directory
//
// Revision 1.1.1.1  2001/11/04 18:51:07  lampret
// First import.
//
//
`ifdef LOAD_IMAGE

module ext_ram_init;

reg [7:0] mem [0:8388607]; //8MBytes


task init_sram;
integer i;
begin
	#1;

	$write("Loading code to RAM ...");
	$readmemh("sw-images/image.dat", mem);
	for (i=0; i < 8388602; i=i+4) begin
		or1200_tb.RAM.block_ram_0.mem[i/4] = mem[i+3];
		or1200_tb.RAM.block_ram_1.mem[i/4] = mem[i+2];
		or1200_tb.RAM.block_ram_2.mem[i/4] = mem[i+1];
		or1200_tb.RAM.block_ram_3.mem[i/4] = mem[i+0];

	end
   $write("done\n");
   
end
endtask

endmodule

`endif
