#!/bin/tcsh
#
# CVS $Id: bootstrap-duv.tcsh,v 1.1 2009/03/31 07:59:02 depaulfm Exp $
#
# Script to setup verification environment
#

setenv TOP $PWD/../../BackSpace

#Replace DUV w/ actual name
setenv MODEL DUV 
setenv SIM sim
setenv TB  tb
setenv SAT $TB/SAT
setenv PERLM $TOP/perl/modules
setenv PERLS $TOP/perl/scripts
setenv TECHMAP $TOP/techmap
setenv MINISAT $TOP/minisat
setenv VER $TOP/verification

setenv BS_PERL_MODULES $PERLM

if (! -f $MODEL) then
    mkdir $MODEL
endif

cd $MODEL

#####
##### Setup DUV/sim directory
#####
if (! -f $SIM) then
    mkdir $SIM
endif
if (! -f $SIM/scripts) then
    cd $SIM; ln -s $PERLS; cd ../
endif
if (! -f $SIM/techmap) then
    cd $SIM; ln -s $TECHMAP; 
    echo "Need to compile design!!" > REMINDER
    cd ../
endif
cd sim; cp $TOP/verification/OpenRISC/sim/build.sh . ; cd ..
#####
##### Setup DUV/tb directory
#####
if (! -f $TB) then
    mkdir $TB
endif
if (! -f $TB/simv) then
     cd $TB; ln -s ../$SIM/simv; cd ../
endif
if (! -f $TB/backspace_sim.pl) then
     cd $TB; ln -s $PERLS/backspace_sim.pl; 
     echo "Need dontcares file!!" > REMINDER
     cd ../
     
endif
#####
##### Setup DUV/tb/SAT directory
#####
if (! -f $SAT) then
    mkdir $SAT; cd $SAT; 
    ln -s $MINISAT/Solver.C
    ln -s $MINISAT/Solver.h
    ln -s $MINISAT/SolverTypes.h
    ln -s $MINISAT/mtl
    ln -s ../cnfLatches.h
    ln -s ../constraints0.h constraints.h
    echo "Need constraint_literals.h!!" > REMINDER
    echo "Need to apply changes to Main.c!!" >> REMINDER
    cp $TOP/verification/OpenRISC/tb/SAT/Makefile .
    cp $TOP/verification/OpenRISC/tb/SAT/Main.C .
    cd ../
endif

cd $VER/$MODEL

echo "\nSetup Completed\!\!\!"
echo "\nCurrent Directory:"
echo $PWD


